#include <stdio.h>
#include <stdlib.h>
#include <winsock.h>
#include <mysql.h>
#include <string.h>
#include <TCHAR.h>
#include "fileMap.h"
#include "md5.h"

#pragma comment(lib, "libmysql.lib")

MYSQL mysql;
int succeedCounter=0;
int failureCounter=0;

FILE* stream;

const char* DefaultHost="76.68.250.205";
const char* DefaultUser="root";
const char* DefaultPassword="202409";
const char* DefaultDatabase="nicktest";
const int DefaultPort=3306;

//_TCHAR* insertStatement=_T("insert into nametable (first_name, last_name) \
//	values(\"nick\", \"huang\")");

//_TCHAR* queryStatement=_T("select * from nametable;");

//_TCHAR* alterStatement=_T("alter table nametable add column image blob");

#define SAFE_CALL(X) if (!X) {_tprintf(_T("error %s\n"), mysql_error(&mysql)); exit(123);}


void displayField(MYSQL_RES* res)
{
	MYSQL_FIELD* field;
	while ((field=mysql_fetch_field(res)))
	{
		_tprintf(_T("field[%s]"), field->name);
	}
}

void displayRow(MYSQL_RES* res)
{
	MYSQL_ROW row;
	int num_fields;
	num_fields = mysql_num_fields(res);
	while ((row=mysql_fetch_row(res)))
	{
		for (int i=0; i<num_fields; i++)
		{
			_tprintf(_T("[%s]"), row[i]);
		}
	}
}

void errHandle(const _TCHAR* reason)
{
	_tprintf(_T("%s error %s\n"), reason, mysql_error(&mysql));
}

void connectDB()
{
	SAFE_CALL(mysql_init(&mysql));
	SAFE_CALL(mysql_real_connect(&mysql, DefaultHost, DefaultUser, DefaultPassword,
		DefaultDatabase, DefaultPort, NULL, 0));
}

void disconnectDB()
{
	mysql_close(&mysql);
}


/*
typedef struct st_mysql_res {
  my_ulonglong row_count;
  MYSQL_FIELD	*fields;
  MYSQL_DATA	*data;
  MYSQL_ROWS	*data_cursor;
  unsigned long *lengths;		/// column lengths of current row/
  MYSQL		*handle;		/ for unbuffered reads /
  MEM_ROOT	field_alloc;
  unsigned int	field_count, current_field;
  MYSQL_ROW	row;			/ If unbuffered read/
  MYSQL_ROW	current_row;		/* buffer to current row /
  my_bool	eof;			/ Used by mysql_fetch_row/
  /* mysql_stmt_close() had to cancel this result /
  my_bool       unbuffered_fetch_cancelled;  
  const struct st_mysql_methods *methods;
} MYSQL_RES;
*/

void calculateMD5(const unsigned char *data, int nbytes, unsigned char digest[16])
{
	md5_state_t state;
	md5_init(&state);
	md5_append(&state, data, nbytes);
	md5_finish(&state, digest);
}


void addSignature(_TCHAR* picture_name)
{
	char buffer[256];
	int selectLength;
	MYSQL_ROW row;
	MYSQL_RES* res;
	unsigned long * lengths;
	unsigned char digest[16];
	const char* selectStatement="select picture_data from mypicture where picture_name=\"";
	sprintf(buffer, "%s", selectStatement);
	selectLength=strlen(selectStatement);
	_stprintf((_TCHAR*)(buffer+selectLength), _T("%s"), picture_name);
	selectLength=strlen(buffer);
	buffer[selectLength]='"';
	buffer[selectLength+1]='\0';

	if (mysql_real_query(&mysql, buffer, selectLength+1))
	{
		_ftprintf(stream, _T("query error %s picture_name=%s\n"), mysql_error(&mysql),
			picture_name);			
	}

	if ((res=mysql_store_result(&mysql))==NULL)
	{
		_ftprintf(stream, _T("store result error %s picture_name=%s\n"), mysql_error(&mysql),
			picture_name);
		return;
	}

	row=mysql_fetch_row(res);
	lengths=mysql_fetch_lengths(res);

	calculateMD5((unsigned char*)row[0], lengths[0], digest);
	for (int i=0; i<16; i++)
	{
		printf("%X", digest[i]);
	}
	mysql_free_result(res);
}

MYSQL_RES* res;
void freeResult()
{
	mysql_free_result(res);
}


void freeResult(void* res)
{
	mysql_free_result((MYSQL_RES*)res);
}


void* selectMediaDataByIndex(int mediaType, int id, char*& ptr, int& length)
{
	char buffer[256];
	MYSQL_ROW row;
	unsigned long * rowLengths;
	MYSQL_RES* res;
	switch (mediaType)
	{
	case 0:
		sprintf(buffer, "select picture_data from mypicture where id=%d;", id);
		break;
	case 1:
		sprintf(buffer, "select music_data from mymusic where id=%d;", id);
		break;
	}

	if (mysql_real_query(&mysql, buffer, strlen(buffer)))
	{
		_ftprintf(stream, _T("query error %s\n"), mysql_error(&mysql));	
		return NULL;
	}

	if ((res=mysql_store_result(&mysql))==NULL)
	{
		_ftprintf(stream, _T("store result error %s\n"), mysql_error(&mysql));
		return NULL;
	}
	if ((row=mysql_fetch_row(res))==NULL)
	{
		errHandle(_T("fetch row"));
		return NULL;
	}

	if ((rowLengths=mysql_fetch_lengths(res))==NULL)
	{
		errHandle(_T("fetch length"));
		return NULL;
	}
	ptr=row[0];
	length=rowLengths[0];
	return res;
}



void* selectPictureByIndex(int id, char*& ptr, int& length)
{
	char buffer[256];
	MYSQL_ROW row;
	unsigned long * rowLengths;
	MYSQL_RES* res;
	sprintf(buffer, "select picture_data from mypicture where id=%d;", id);
	if (mysql_real_query(&mysql, buffer, strlen(buffer)))
	{
		_ftprintf(stream, _T("query error %s\n"), mysql_error(&mysql));	
		return NULL;
	}

	if ((res=mysql_store_result(&mysql))==NULL)
	{
		_ftprintf(stream, _T("store result error %s\n"), mysql_error(&mysql));
		return NULL;
	}
	if ((row=mysql_fetch_row(res))==NULL)
	{
		errHandle(_T("fetch row"));
		return NULL;
	}

	if ((rowLengths=mysql_fetch_lengths(res))==NULL)
	{
		errHandle(_T("fetch length"));
		return NULL;
	}
	ptr=row[0];
	length=rowLengths[0];
	return res;
}

int selectBatchPicture(int idStart, int number, char*results[], int lengths[])
{
	int i;
	const char* selectStatement="select picture_data from mypicture where id";
	char buffer[256];
	MYSQL_ROW row;
	unsigned long * rowLengths;
	sprintf(buffer, "%s between %d and %d;", selectStatement, idStart, idStart+number);
	if (mysql_real_query(&mysql, buffer, strlen(buffer)))
	{
		_ftprintf(stream, _T("query error %s\n"), mysql_error(&mysql));	
		return -1;
	}

	if ((res=mysql_store_result(&mysql))==NULL)
	{
		_ftprintf(stream, _T("store result error %s\n"), mysql_error(&mysql));
		return -1;
	}
	for (i=0; i<number; i++)
	{
		if ((row=mysql_fetch_row(res))==NULL)
		{
			errHandle(_T("fetch row"));
			return i-1;
		}


		if ((rowLengths=mysql_fetch_lengths(res))==NULL)
		{
			errHandle(_T("fetch length"));
			return i-1;
		}
		results[i]=row[0];
		lengths[i]=rowLengths[0];
	}
	return i;
	//
}

/*				
void insertFile(_TCHAR* fullName, _TCHAR* fileName)
{
	DWORD size;
	_TCHAR* namePtr;
	unsigned char digest[16];
	int dataLength, signatureLength, firstLength, nameLength;
	const char* insertFirst="insert into mypicture (picture_time, picture_size, picture_name, picture_signature, picture_data) values (now()";

	const char* insertLast="\")";
	//char* binaryData;
	char* buffer=NULL;
	char* ptr=NULL;

	nameLength=_tcsclen(fileName);
	
	namePtr=fileName+nameLength-3;
	if (!(_tcsicmp(namePtr,  _T("bmp"))==0||
			_tcsicmp(namePtr, _T("jpg"))==0||
			_tcsicmp(namePtr, _T("png"))==0))
	{
		return;						
	}

	if (!mapFile(fullName, ptr, size))
	{
		_ftprintf(stream, _T("fileMapping error %d fullName=%s fileName=%s\n"), GetLastError(),
			fullName, fileName);		
		failureCounter++;
	}
	else
	{
		buffer=new char[size*2+1024];
		if (buffer==NULL)
		{
			_tprintf(_T("alloc mem failed\n"));
			unmapFile(ptr);
			return ;
		}

		calculateMD5((unsigned char*)ptr, size, digest);
		sprintf(buffer, "%s,%d,", insertFirst, size);
		firstLength=strlen(buffer);

		_stprintf((_TCHAR*)(buffer+firstLength), _T("\"%s\",\""), fullName);

		firstLength=strlen(buffer);

		signatureLength=mysql_real_escape_string(&mysql, buffer+firstLength, (const char*)digest, 16);
		
		firstLength+=signatureLength;
		buffer[firstLength]='"';
		firstLength++;
		buffer[firstLength]=',';
		firstLength++;
		buffer[firstLength]='"';
		firstLength++;
		
	
		dataLength=mysql_real_escape_string(&mysql, buffer+firstLength, ptr, size);

	
		memcpy(buffer+dataLength+firstLength, insertLast, strlen(insertLast));

		if (mysql_real_query(&mysql, buffer, dataLength+firstLength+strlen(insertLast)))
		{
			_ftprintf(stream, _T("query error %s file name=%s filesize=%d\n"), mysql_error(&mysql),
				fileName, size);
			_ftprintf(stream, _T("fullName %s \n"), fullName);
			
			//_tprintf(_T("query error %s file name=%s filesize=%d\n"), mysql_error(&mysql),
			//	fileName, size);
			failureCounter++;
		}
		else
		{
			succeedCounter++;
		}
		delete[]buffer;
		unmapFile(ptr);
	}
}
*/


void insertFile(_TCHAR* fullName, _TCHAR* fileName)
{
	DWORD size;
	_TCHAR* namePtr;
	unsigned char digest[16];
	int dataLength, signatureLength, firstLength, nameLength;
	const char* insertFirst="insert into mymusic (music_time, music_size, music_name, music_signature, music_data) values (now()";

	const char* insertLast="\")";
	//char* binaryData;
	char* buffer=NULL;
	char* ptr=NULL;

	nameLength=_tcsclen(fileName);
	
	namePtr=fileName+nameLength-3;
	if (!(_tcsicmp(namePtr,  _T("mp3"))==0||
			_tcsicmp(namePtr, _T("mid"))==0||
			_tcsicmp(namePtr, _T("wav"))==0||
			_tcsicmp(namePtr, _T("mpg"))==0||
			_tcsicmp(namePtr, _T("wmv"))==0))
	{
		return;						
	}

	if (!mapFile(fullName, ptr, size))
	{
		_ftprintf(stream, _T("fileMapping error %d fullName=%s fileName=%s\n"), GetLastError(),
			fullName, fileName);		
		failureCounter++;
	}
	else
	{
		buffer=new char[size*2+1024];
		if (buffer==NULL)
		{
			_tprintf(_T("alloc mem failed\n"));
			unmapFile(ptr);
			return ;
		}

		calculateMD5((unsigned char*)ptr, size, digest);
		sprintf(buffer, "%s,%d,", insertFirst, size);
		firstLength=strlen(buffer);

		_stprintf((_TCHAR*)(buffer+firstLength), _T("\"%s\",\""), fullName);

		firstLength=strlen(buffer);

		signatureLength=mysql_real_escape_string(&mysql, buffer+firstLength, (const char*)digest, 16);
		
		firstLength+=signatureLength;
		buffer[firstLength]='"';
		firstLength++;
		buffer[firstLength]=',';
		firstLength++;
		buffer[firstLength]='"';
		firstLength++;
		
	
		dataLength=mysql_real_escape_string(&mysql, buffer+firstLength, ptr, size);

	
		memcpy(buffer+dataLength+firstLength, insertLast, strlen(insertLast));

		if (mysql_real_query(&mysql, buffer, dataLength+firstLength+strlen(insertLast)))
		{
			_ftprintf(stream, _T("query error %s file name=%s filesize=%d\n"), mysql_error(&mysql),
				fileName, size);
			_ftprintf(stream, _T("fullName %s \n"), fullName);
			
			//_tprintf(_T("query error %s file name=%s filesize=%d\n"), mysql_error(&mysql),
			//	fileName, size);
			failureCounter++;
		}
		else
		{
			succeedCounter++;
		}
		delete[]buffer;
		unmapFile(ptr);
	}
}

void outputFileName(_TCHAR* fullName, _TCHAR* fileName)
{
	_ftprintf(stream, _T("full name %s\n filename %s\n"), fullName, fileName);
}

void addDirectory(TCHAR* dir)
{
	succeedCounter=failureCounter=0;
	//if (mysql_query(&mysql, queryStatement))
	//if (mysql_query(&mysql, insertStatement))
	stream=fopen("result.txt", "w");

	genericFind(dir, insertFile);
	_ftprintf(stream, _T("succeed=%d, failure=%d\n"), succeedCounter, failureCounter);
	fclose(stream);
	_tprintf(_T("succeed=%d, failure=%d\n"), succeedCounter, failureCounter);
}


int _tmain(int argc, TCHAR** argv)
{
	connectDB();

	addDirectory(_T("f:\\music"));

	disconnectDB();

	return 0;
}







